import subprocess, os, sys, time
from datetime import datetime
from socket import gethostname


# each experiment will be Nhours in duration
Nhours = 2.0

# create a dir for this experiment
wifi_dir = "/wifi"
 


def usage():
    return """
    This script will run aircrack for Nhours, 
    gathering IVs.

        python AircrackIVs.py wlan1

    """

if len(sys.argv)<>2:
    raise Exception(usage())

script_name = sys.argv[0]
interface_name = sys.argv[1]

# create a unique file prefix for this experiment
date_prefix = datetime.now().strftime('%Y-%m-%d_%H-%M-%S')

hostname = gethostname()

file_prefix = hostname+'_'+date_prefix

subprocess.call(["mkdir","-p",wifi_dir])

subprocess.call(["killall","airodump-ng"])

print("[%s] About to put card in monitor mode."%(script_name) )
subprocess.call(['ifconfig',interface_name,'down'])
subprocess.call(['iwconfig',interface_name,'mode','monitor'])
subprocess.call(['ifconfig',interface_name,'up'])
print "Done."

# construct the airodump command and pipe all its output to /dev/null so it doesn't blow up the syslog
FNULL = open(os.devnull,'w')
the_cmd = ['airodump-ng',interface_name,'-w',file_prefix,'-o','ivs']

# call it
p = subprocess.Popen(the_cmd,
        stdout=FNULL, stderr=subprocess.STDOUT,
        cwd=wifi_dir)

# wait for it
time.sleep(Nseconds)

# aaaaand bail 
p.kill()
 
print("[%s] Success!"%(script_name) )

